package myutil;

/**
 * Ricerca binaria su di un array di stringhe
 */
public final class BinSearch {
    private BinSearch() {};
    
    /**
     * Ricerca binaria su di una sezione di un array di stringhe
     *
     * @param sA    array in cui cercare
     * @param from  indice iniziale della sezione
     * @param to    indice finale della sezione
     * @param s     stringa da cercare
     * @return      l'indice della stringa se presente nel vettore,
     *              oppure -(indiceInserimento+1), dove indiceInserimento
     *              e' la posizione in cui va inserita la stringa
     *              Se from > to il risultato non e' definito
     */
    public static int binarySearch(String[] sA, int from, int to, String s) {
        int m = (to+from)/2;            // la mediana della sezione
        int i = sA[m].compareTo(s);     // confronta con la stringa mediana
        if (i == 0)                     // trovato
            return m;
        else if (i > 0)                 // mediana viene dopo
            to = m-1;
        else                            // mediana viene prima
            from = m+1;
        if (from > to)                  // assente
            return -from;
        else
            return binarySearch(sA, from, to, s);           
    }

    /**
     * Ricerca binaria su di un array di stringhe
     *
     * @param sAr
     * @param s
     * @return
     */
//    public static int binarySearch(String[] sAr, String s) {
//        return 0;
//    }
}
