package myutil;

import java.util.Comparator;
import java.util.Arrays;

/**
 * Ricerca binaria su di un array di stringhe
 * Utilizza le funzioni di libreria di Java 6
 */
public final class BinSearch6 {

    private static final class StringComparator implements Comparator<String> {
        public int compare(String s1, String s2) {
            return (s1.compareTo(s2));
        }
    }
    private static final Comparator<String> comp = new StringComparator();

    /**
     * Ricerca binaria su di una sezione di un array di stringhe
     *
     * @param sA    array in cui cercare
     * @param from  indice iniziale della sezione
     * @param to    indice finale della sezione
     * @param s     stringa da cercare
     * @return      l'indice della stringa se presente nel vettore,
     *              oppure -(indiceInserimento-1), dove indiceInserimento
     *              e' la posizione in cui va inserita la stringa
     *              Se from > to il risultato non e' definito
     */
    public static int binarySearch(String[] sAr, int from, int to, String s) {
        return(Arrays.binarySearch(sAr, to, from, s, comp));
    }
}
