package strsets; 

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

/**
 * Dizionario di parole memorizzato su file
 * Implementa StrSet
 */
public class Dictionary implements StrSet {
    private File fileDict;      // il file del dizionario
    private Scanner scanDict;   // per scandire il file del dizionario
    private int size = -1;      // num elemwnti nel dizionario

    /**
     * Costruisce una nuova istanza
     * Assume che il file esista e contenga le parole
     * 
     * @param file          il file del dizionario
     * @return              il dizionario vuoto
     */
    public Dictionary(File file) throws FileNotFoundException {
        fileDict = file;
        scanDict = new Scanner(fileDict);
    }

    /**
     * Riporta il cursore del file all'inizio
     */
    public void rewind() throws FileNotFoundException {
        scanDict.close();
        scanDict = new Scanner(fileDict);
    }

    /**
     * Prende la successiva parola dal dizionario
     * 
     * @return      la successiva parola se presente
     */
    public String next() {
        if (scanDict.hasNext())
            return scanDict.next();
        else
            return null;
    }

    /**
     * Verifica se una stringa e' contenuta nell'insieme
     * (implementazione di un metodo dell'interfaccia)
     * 
     * @param s     la stringa
     * @return      true se la stringa e' contenuta, false altrimenti
     */
    public boolean contains(String s) {
        try {                   // non pu usare la dichiarazione throws perch
            rewind();           // questa non  prevista dall'interfaccia
        } catch (FileNotFoundException ex) { return false; }
        while (scanDict.hasNext())
            if (scanDict.next().equals(s))
                return true;
        return false;
    }

    /**
     * Dimensione dell'insieme
     * (implementazione di un metodo dell'interfaccia)
     * 
     * @return      il numero di stringhe nell'insieme
     */
    public int size() {
        if (size == -1) {
             try {               // non pu usare la dichiarazione throws perch
                 rewind();       // questa non e' prevista dall'interfaccia
             } catch (FileNotFoundException ex) {
                 return 0;
             }
             size = 0;
             while (scanDict.hasNext())
                size++;
        }
        return size;
    }
}