package strsets; 

/**
 * Una semplice implementazione di StrSet
 */
public class KeywordSet implements StrSet {
    // L'insieme di stringhe e' implementato con un array
    String[] keywords;
    
    /**
     * Costruisce un insieme di keywords copiandole da un array
     * 
     * @param kA    array di keywords
     * @return      l'insieme contenente una copia delle keywords
     */
    public KeywordSet(String[] kA) {
        // l'array deve essere clonato per evitare
        // che modificando l'array fornito in input kA
        // si modfichi anche questo insieme
        keywords = kA.clone();
    }

    /**
     * Verifica se una stringa e' contenuta nell'insieme
     * (implementazione di un metodo dell'interfaccia)
     * 
     * @param s     la stringa
     * @return      true se la stringa e' contenuta, false altrimenti
     */
    public boolean contains(String s) {
        for (int i = 0 ; i < keywords.length ; i++)
            if (keywords[i].equals(s))
                return true;
        return false;
    }

    /**
     * Dimensione dell'insieme
     * (implementazione di un metodo dell'interfaccia)
     * 
     * @return      il numero di stringhe nell'insieme
     */
    public int size() {
        return keywords.length;
    }
}